//***** Bluetooth Speaker Wifi Clock ESP-01  Crazy Indiana*****//
/*************************************************************
*  CRAZY INDIANA Bluetooth Speaker Wifi Clock                 *
*  Website www.crazyindiana.in                                *
*  Youtube www.youtube.com/c/CrazyIndiana                     *
**************************************************************/

//Sends Date Time & Temp/Hum to Arduino Nano for ESP-01//

#include <SPI.h>
#include <Wire.h>
#include <NTPClient.h>
#include <WiFiUdp.h>
#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h> // http web access library
#include <ArduinoJson.h> // JSON decoding library
//#include <SoftwareSerial.h>

// Your Router/Hotspot id/password
const char *ssid     = "BidRM";
const char *password = "bidwifi";

// set location and API key for OpenWeather
String Location = "Kolkata,India"; // Your Location
String API_Key = "e0d5690b1226870ffb6842a58xxxxxxx";  // Your API Key

// Define NTP Client to get time
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "pool.ntp.org");

unsigned long epochTime;
String strDateE;
String strTempE;
int intset=1;
int intxday=0; // week day
int intCTemp = 0; // stores current day Temp 
int intCHum = 0;  // stores current day  Hum
bool am = true;
char TempD[12]; // date
char TempH[4]; //Temp


void setup() 
{
   Serial.begin(9600);
   //------------------------------ Connect to Wi-Fi
        Serial.print("Connecting to ");
        Serial.println(ssid);
        Serial.println("Conn Net");
        WiFi.begin(ssid, password);
        while (WiFi.status() != WL_CONNECTED) 
        {
        delay(1000);
        Serial.print(".");
        }
        Serial.println(WiFi.localIP());
        delay(2000);
               
        // Initialize a NTPClient to get time
        timeClient.begin();
        // Set offset time in seconds to adjust for your timezone, for example:GMT +1 = 3600,// GMT 0 = 0
        timeClient.setTimeOffset(19800);//India change to your location.
        delay(2000);
        updatetime();
        delay(2000);
        GetTempHum();
//-------------------------------------------  
}

void loop() 

{
    writeString(strDateE);
    writeString(strTempE);
    delay(2000);
}

///Function//-----------
void updatetime()
{
    String strmonthDay ;
    String strcurrentMonth;
    String strcurrentHour;
    String strcurrentMinute;
    
    timeClient.update();
    epochTime = timeClient.getEpochTime();
    Serial.print("Epoch Time: ");
    Serial.println(epochTime);

    int currentHour = timeClient.getHours();
    int currentMinute = timeClient.getMinutes();
    //Get a time structure
    struct tm *ptm = gmtime ((time_t *)&epochTime); 
    int monthDay = ptm->tm_mday;
    int currentMonth = ptm->tm_mon+1;
    int currentYear = ptm->tm_year+1900;

    if (currentHour<10) 
    strcurrentHour = "0" + String(currentHour);
    else
    strcurrentHour= String(currentHour);

    if (currentMinute<10)
    strcurrentMinute = "0" + String(currentMinute);
    else
    strcurrentMinute = String(currentMinute);
    
    if (monthDay<10) 
    strmonthDay ="0"+String(monthDay);
    else
    strmonthDay =String(monthDay);

    if (currentMonth<10) 
    strcurrentMonth ="0"+String(currentMonth);
    else
    strcurrentMonth =String(currentMonth);

    strDateE= strcurrentHour + strcurrentMinute + strmonthDay+ strcurrentMonth+String(currentYear);
   
    
}

//-----Get Current Temp & Hum  from Openweather.com ------------//
void GetTempHum()
  {
    String strtemp;
    String strhum;
    // Getting Weather Data//
    if (WiFi.status() == WL_CONNECTED) //Check WiFi connection status
      { 
        HTTPClient http; //Declare an object of class HTTPClient
        //http.begin("http://api.openweathermap.org/data/2.5/weather?q=" + Location + "&APPID=" + API_Key); // !!ok 1 day
        http.begin("http://api.openweathermap.org/data/2.5/weather?q=" + Location + "&cnt=3&APPID=" + API_Key); // !! 3 days
        int httpCode = http.GET(); // send the request
        if (httpCode > 0) // check the returning code
        {
            String payload = http.getString(); //Get the request response payload
            StaticJsonDocument <512> doc;
            deserializeJson(doc, payload);

        
            float temp = (float)(doc["main"]["temp"])- 273.15;
            auto humidity = doc["main"]["humidity"].as<int>();
            float pressure = (float)(doc["main"]["pressure"])/1000;
            auto wind_speed = doc["wind"]["speed"] .as<float>();
            int wind_degree = doc["wind"]["deg"];
            intCTemp = round(temp);
            intCHum = round(humidity);
            
          //  int memoryUsed = doc.memoryUsage();
       
          }
        http.end(); //Close connection

         if (intCTemp<10) 
          strtemp ="0"+String(intCTemp);
         else
         strtemp =String(intCTemp);
         
         if (intCHum<10) 
         strhum ="0"+String(intCHum);
         else
         strhum =String(intCHum);
        
        strTempE=strtemp +strhum;
      }
  }
//--------------------------------------------//
// Used to serially push out a String with Serial.write()
void writeString(String stringData) 
{ 
  for (int i = 0; i < stringData.length(); i++)
  {
    Serial.write(stringData[i]);  
  }
    
    
}// end writeString
